#!/usr/local/bin/perl
#
# This script will construct a list of databases from the 
# db directory which can be searched. 
#
# The database name will not show up is an authorization
# id is required and the user is restricted by $ZACCESS.
# 
# Author: Harold Finkbeiner (harold@lindy.stanford.edu)
#
# Setup the site variables

do "site.pl";

do "env.pl" unless ($ENV{REMOTE_ADDR});

$HREF = "http://$ENV{SERVER_NAME}:$ENV{SERVER_PORT}$ENV{SCRIPT_NAME}";
$HREF =~ s|/[^/]+.CGI$|/zform.CGI|;

$| = 1;

print <<"directory-introduction";
Content-type: text/html

<HTML>
<HEAD>
<TITLE>$ZHEADER</TITLE>
</HEAD>
<BODY>
<H1><IMG SRC="image/WorldBooks.gif" ALIGN=MIDDLE ALT=DB> $ZHEADER</H1>
<P>
DB Connect is an <B>experimental</B> service providing access to bibliographic
databases via the World Wide Web for the Stanford community.  It utilizes
progress made by 
<A HREF="http://ds.internic.net/z3950/z3950.html">Z39.50</A> and the
<A HREF="http://lindy.stanford.edu/~harold/z3950/www_gateway.html">Z39.50
to WWW Gateway</A> to search and retrieve information over the network.
</P>
<P>
Since these database connections are happening over the Internet, you
may experience momentary delays while information is transmitted. Please
be patient and try again later if your first attempt is unsuccessful.
If problems persist, however, send a message to 
<A HREF="mailto:harold\@lindy.stanford.edu">harold\@lindy.stanford.edu</A>.
</P>
<P>
We are pleased to include
<A HREF="$HREF?PSOC">Socrates</A>,  
Stanford Libraries' Catalog as well as other resources.  You may also
search Socrates automatically from another collection (eg. Melvyl) when
the appropriate information is available.
</P>
<HR>
<H2>Database Directory</H2>
<DL>
directory-introduction

opendir(DBL, 'db');
@dblist = sort grep(!/^\./, readdir(DBL));
closedir(DBL);

foreach (@dblist) {
   next if (   (/^P(AMC|BKS|FLM|MAP|MDF|REC|SER|SCO)$/)
            && ($ENV{SERVER_NAME} =~ m/stanford.edu$/));


# Change the script name to submit the form.
#
# The profile may contain a $ZFORM_SCRIPT variable with the
# name of the script to use, otherwise use search.CGI.

   do "db/$_";

   next if ($AUTHORIZATION_ID && $ENV{REMOTE_ADDR} !~ m/$ZACCESS/);

   print "<DT><A HREF=\"$HREF?$_\"><B>$FULL_NAME</B></A><DD>\n";
   print "$BEFORE_TEXT";
}

print <<"directory-conclusion";
</DL>
$ADDRESS
</BODY>
</HTML>
directory-conclusion
