#!/usr/local/bin/perl
#
#
# This will filter SUTR records from the zclient and add HTML formatting. 
#
# Author: Harold Finkbeiner (harold@lindy.stanford.edu)
#

print '<PRE>';

if ($elemname eq 'F')  { &full_display(); }
else                   { &brief_display(); }

print '</PRE>';

sub full_display {
    while (<STDIN>) {
        last if (m/^-END-OF-DISPLAY-COMMAND-OUTPUT-$/);

        if (m/^(\s*)([A-Z \.,]+):(.*)/) {
            print "$1<B>$2:</B>$3";
        }    
        elsif (m/^Record/) {
            print "\n<H3>$_</H3>\n";
        }
        else {
            print ' ' . $_;
        }    
    }
}

sub brief_display {
   $HREF = "http://$ENV{SERVER_NAME}:$ENV{SERVER_PORT}$ENV{SCRIPT_NAME}?$ENV{QUERY_STRING}";

    while (<STDIN>) {
        last if (m/^-END-OF-DISPLAY-COMMAND-OUTPUT-$/);

        if (m/^              /) {
            print ' ' . $_;
        }
        elsif (m/^(\s*)([A-Z \.,]+):(.*)/) {
            print "$1<B>$2:</B>$3";
        }   

        elsif (m/^Record/) {

            ($word, $number) = split;
    
            # Create the hypertext link for the record
    
            $_ = $HREF;
            $_ .= "&start=$number" unless (s/&start=\d+/&start=$number/);
            $_ .= '&records=1'     unless (s/&records=\d+/&records=1/);
            $_ .= '&elemname=F'    unless (s/&elemname=\w+/&elemname=F/);
    
            print "\n<B><A HREF=\"$_\">$word $number</A></B>\n";
        }  
    }   
}   
